﻿using System.ComponentModel;

namespace SelfReferenceHierarchyTreeView
{
	public class DataItem : INotifyPropertyChanged
	{
		private string text;

		public event PropertyChangedEventHandler PropertyChanged;

		public int ID { get; set; }

		public int ParentID { get; set; }

		public DataItemCollection Owner { get; private set; }

		public string Text
		{
			get
			{
				return this.text;
			}
			set
			{
				if (this.text != value)
				{
					this.text = value;
					this.OnPropertyChanged("Text");
				}
			}
		}

		protected void OnPropertyChanged(string propertyName)
		{
			if (this.PropertyChanged != null)
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}

		internal void SetOwner(DataItemCollection collection)
		{
			this.Owner = collection;
		}
	}
}