﻿using System.Collections.ObjectModel;

namespace SelfReferenceHierarchyTreeView
{
	public class DataItemCollection : ObservableCollection<DataItem>
	{
		protected override void InsertItem(int index, DataItem item)
		{
			item.SetOwner(this);
			base.InsertItem(index, item);
		}

		protected override void RemoveItem(int index)
		{
			this[index].SetOwner(null);
			base.RemoveItem(index);
		}

		protected override void SetItem(int index, DataItem item)
		{
			item.SetOwner(this);
			base.SetItem(index, item);
		}

		protected override void ClearItems()
		{
			foreach (DataItem item in this)
			{
				item.SetOwner(null);
			}
			base.ClearItems();
		}
	}
}